#include "dof6.h"
 #include "6dof_hal.h"
 #include "6dof_hw.h"

// TFT module connections
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_RST at GPIOE_ODR.B8;
 sbit TFT_BLED at GPIOE_ODR.B9;
// End TFT module connections


uint8_t temp_data[5];

static inline void dof6_enable_all_interupts()
                                {
                                dof6_set_int_orient_en(true);
                                dof6_set_int_flat_en(true);
                                dof6_set_int_s_tap_en( true );
                                dof6_set_int_tap_shock(true);
                                dof6_set_int_tap_quiet(true);
                                dof6_set_int_d_tap_en(true);
                                dof6_set_int_anymo_x_en(true);
                                dof6_set_int_anymo_y_en(true);
                                dof6_set_int_anymo_z_en(true);
                                dof6_set_int_fwm_en(true);
                                dof6_set_int_ffull_en(true);
                                dof6_set_int_drdy_en(true);
                                dof6_set_int_low_en (true);
                                dof6_set_int_highz_en (true);
                                dof6_set_int_highy_en (true);
                                dof6_set_int_highx_en (true);
                                dof6_set_int_step_det_en(true);
                                dof6_set_int_nomoz_en(true);
                                dof6_set_int_nomoy_en(true);
                                dof6_set_int_nomox_en(true);
                                }

static void Display_Init() {
        TFT_Set_Default_Mode();
        TFT_Init_ILI9341_8bit(320, 240);
        TFT_BLED = 1;
        TFT_Fill_Screen(CL_RED);
        TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
        TFT_Write_Text("6 DOF IMU 2", 120, 20);

}

static void Sensor_Config (char cmd1, char cmd2)
{
        uint8_t temp=CMD;
        uint8_t temp_data1 = cmd1;
        uint8_t temp_data2 = cmd2;
        dof6_hal_write( &temp,&temp_data1,1  );
        dof6_hal_write( &temp,&temp_data2,1  );
}


void main() {
        uint8_t txt1[20],txt2[20],txt3[20],txt4[20],txt5[20],txt6[20];
        float a,b,c,d,e,f;
        int i=14;
        Display_Init();
        I2C1_Init();
        dof6_hal_init(BMI160_I2C_ADDRESS );
        Sensor_Config(accel_normal , gyro_normal);
        dof6_enable_all_interupts();
        while (1)
        {
        TFT_Fill_Screen(CL_RED);
        TFT_Write_Text("6 DOF IMU 2", 100, 20);
        a=dof6_get_acc_x();
        b=dof6_get_acc_y();
        c=dof6_get_acc_z();
        d=dof6_get_gyr_x();
        e=dof6_get_gyr_y();
        f=dof6_get_gyr_z();
        FloatToStr(a,txt1);
        FloatToStr(b,txt2);
        FloatToStr(c,txt3);
        FloatToStr(d,txt4);
        FloatToStr(e,txt5);
        FloatToStr(f,txt6);
        TFT_Write_Text("acc x :", 30, 60);
        TFT_Write_Text(txt1,30,80);
        TFT_Write_Text("acc y :", 30, 120);
        TFT_Write_Text(txt2,30,140);
        TFT_Write_Text("acc z :", 30, 180);
        TFT_Write_Text(txt3,30,200);
        TFT_Write_Text("gyr x :", 210, 60);
        TFT_Write_Text(txt4,210,80);
        TFT_Write_Text("gyr y :", 210, 120);
        TFT_Write_Text(txt5,210,140);
        TFT_Write_Text("gyr z :", 210, 180);
        TFT_Write_Text(txt6,210,200);
        Delay_ms(2000);
        }
}