#include "resources.h"
#include "6dof.h"
#include "6dof_hal.h"
#include "6dof_hw.h"

uint8_t txt1[20];
float acc_x,acc_y,acc_z,gyro_x,gyro_y,gyro_z;

static void Display_Init() {
  TFT_Set_Default_Mode();
  TFT_Init_ILI9341_8bit(320, 240);
  TFT_BLED = 1;
  TFT_Fill_Screen(CL_TEAL);
  TFT_Set_Pen(CL_BLACK, 1);
  TFT_Line(20, 220, 300, 220);
  TFT_Line(20,  46, 300,  46);
  TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLACK, FO_HORIZONTAL);
  TFT_Write_Text("6DOF IMU 2  Click  Board  Demo", 20, 14);
  TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
  TFT_Write_Text("EasyMx PRO v7 for STM32", 19, 223);
  TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
  TFT_Write_Text("www.mikroe.com", 200, 223);
  TFT_Set_Pen(CL_TEAL, 1);
  TFT_Set_Brush(1,CL_TEAL,0,0,0,0);
  
  TFT_Write_Text("acc x :", 30, 60);
  TFT_Write_Text("acc y :", 30, 120);
  TFT_Write_Text("acc z :", 30, 180);
  TFT_Write_Text("gyr x :", 210, 60);
  TFT_Write_Text("gyr y :", 210, 120);
  TFT_Write_Text("gyr z :", 210, 180);
  
}



void display_data()
{

      acc_x=dof6_get_acc_x();
      acc_y=dof6_get_acc_y();
      acc_z=dof6_get_acc_z();
      gyro_x=dof6_get_gyr_x();
      gyro_y=dof6_get_gyr_y();
      gyro_z=dof6_get_gyr_z();

      sprintf(txt1, "%.2f", acc_x);
      TFT_Rectangle(30,80,80,100);
      TFT_Write_Text(txt1,30,80);

      sprintf(txt1, "%.2f", acc_y);
      TFT_Rectangle(30,140, 80, 160);
      TFT_Write_Text(txt1,30,140);
      
      sprintf(txt1, "%.2f", acc_z);
      TFT_Rectangle(30,200, 80, 210);
      TFT_Write_Text(txt1,30,200);
      
      sprintf(txt1, "%.2f", gyro_x);
      TFT_Rectangle(210,80, 260, 100);
      TFT_Write_Text(txt1,210,80);

      sprintf(txt1, "%.2f", gyro_y);
      TFT_Rectangle(210,140, 260, 160);
      TFT_Write_Text(txt1,210,140);

      sprintf(txt1, "%.2f", gyro_z);
      TFT_Rectangle(210,200, 260, 210);
      TFT_Write_Text(txt1,210,200);
      
}

void main() {

        Display_Init();
        I2C1_Init();
        dof6_hal_init(BMI160_I2C_ADDRESS );
        dof6_sensor_config(accel_normal , gyro_normal);

        while (1)
        {
           display_data();
           Delay_ms(50);
        }
}